package org.richfaces.component.event;

import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;

/**
 * Created by IntelliJ IDEA.
 * User: bernard
 * Date: Aug 17, 2010
 * Time: 2:59:13 PM
 */
public class CoordinatesSelectionEvent extends FacesEvent {

    private int startX;
    private int startY;
    private int endX;
    private int endY;

    public CoordinatesSelectionEvent(int startX, int startY, int endX, int endY, UIComponent component) {
        super(component);
        this.startX = startX;
        this.startY = startY;
        this.endX = endX;
        this.endY = endY;
    }

    @Override
    public boolean isAppropriateListener(FacesListener listener) {
        return listener instanceof CoordinatesSelectionListener;
    }

    @Override
    public void processListener(FacesListener listener) {
        ((CoordinatesSelectionListener) listener).coordinatesSelected(this);
    }

    public int getStartX() {
        return startX;
    }

    public int getStartY() {
        return startY;
    }

    public int getEndX() {
        return endX;
    }

    public int getEndY() {
        return endY;
    }
}
