if (!window.Richfaces) window.Richfaces = {};

Richfaces.FocusManager = (function() {

    var m_focus;
    var m_priority = 999999;
    var m_domLoaded = false;
    var m_timing = false;
    var m_focusStore = {};
    /** Constants */
    var TIMING_ON_JS_CALL = "onJScall";
    var TIMING_ON_LOAD = "onload";

    var focus = function(element) {
        try {
            if (element == null) {
                if (m_focus == null) {
                    return;
                }
                element = $(m_focus);
            }
            if (element != null) {
                element.focus();
                element.select(element);
            }
        } finally {
            Richfaces.FocusManager.clearFocus();
        }
    };

    document.observe('dom:loaded', function() {
        if (m_timing == TIMING_ON_LOAD) {
            focus(null);
        }
        m_domLoaded = true;
    });

    return {
        focus: focus,
        focusStored: function(focusComponentId) {
            var element = $(m_focusStore[focusComponentId]);
            if (element != null) {
                focus(element);
            }
        },
        getFocus : function() {
            return m_focus;
        },
        setFocus : function(id, priority, focusComponentId, timing) {
            if (priority == null) {
                priority = 99999;
            }
            if (timing != TIMING_ON_JS_CALL) {
                timing = TIMING_ON_LOAD;
            }
            if (focusComponentId != null) {
                m_focusStore[focusComponentId] = id;
            }
            if (m_focus == null || priority < m_priority) {
                m_focus = id;
                m_priority = priority == null ? 0 : priority;
                m_timing = timing;
                if (m_domLoaded && timing == TIMING_ON_LOAD) {
                    focus();
                }
            }
        },
        clearFocus : function() {
            m_focus = null;
            m_priority = 999999;
            m_timing = null;
        }
    };
})();
