package org.richfaces.component;

import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.component.UIComponentBase;

public abstract class UIGmapMarker extends UIComponentBase {
// ------------------------------ FIELDS ------------------------------

    public static final String COMPONENT_FAMILY = "org.richfaces.GmapMarker";

    public static final String COMPONENT_TYPE = "org.richfaces.GmapMarker";
    public static final boolean DEFAULT_AUTO_PAN = true;
    public static final Double DEFAULT_BOUNCE_GRAVITY = 1d;
    public static final boolean DEFAULT_DRAG_CROSS_MOVE = false;
    public static final boolean DEFAULT_HIDE = false;

// -------------------------- OTHER METHODS --------------------------

    public abstract Double getBounceGravity();

    public abstract String getIcon();

    public abstract Integer getIconHeight();

    public abstract Integer getIconWidth();

    public abstract Double getLatitude();

    public abstract Double getLongitude();

    public abstract String getOnclick();

    public UIGmap getParentMap() {
        UIComponent parent = getParent();
        while (parent != null && !(parent instanceof UIGmap)) {
            parent = parent.getParent();
        }
        if (parent == null) {
            throw new FacesException("Component " + getId() + " must be nested within gmap component.");
        }
        return (UIGmap) parent;
    }

    public abstract String getTitle();

    public abstract boolean isAutoPan();

    public abstract boolean isBouncy();

    public abstract boolean isClickable();

    public abstract boolean isDragCrossMove();

    public abstract boolean isDraggable();

    public abstract boolean isHide();

    public abstract void setAutoPan(boolean autoPan);

    public abstract void setBounceGravity(Double bounceGravity);

    public abstract void setBouncy(boolean bouncy);

    public abstract void setClickable(boolean clickable);

    public abstract void setDragCrossMove(boolean dragCrossMove);

    public abstract void setDraggable(boolean draggable);

    public abstract void setHide(boolean hide);

    public abstract void setIcon(String icon);

    public abstract void setIconHeight(Integer height);

    public abstract void setIconWidth(Integer width);

    public abstract void setLatitude(Double latitude);

    public abstract void setLongitude(Double longitude);

    public abstract void setOnclick(String onclick);

    public abstract void setTitle(String title);
}
