/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */

window.RichFaces = window.RichFaces || {};
RichFaces.GmapMarkers = [];
RichFaces.addGmapMarker = function(gmapVar, lat, lng, options, infoWindowId) {
    RichFaces.GmapMarkers.push({gmapVar:gmapVar,lat:lat,lng:lng,options:options,infoWindowId:infoWindowId});
    RichFaces.handleGmapInit(gmapVar)
};
RichFaces.handleGmapInit = function(gmapVar, event) {
    var gmap = window[gmapVar];
    if (gmap == null) {
        return;
    }
    while (RichFaces.GmapMarkers.length > 0) {
        var data = RichFaces.GmapMarkers.pop();
        if (data.options.icon != null) {
            data.options.icon = new GIcon(G_DEFAULT_ICON, data.options.icon);
            if (data.options.iconWidth != null) {
                data.options.icon.iconSize = new GSize(data.options.iconWidth, data.options.iconHeight);
            }
        }
        var marker = new GMarker(new GLatLng(data.lat, data.lng, true), data.options);
        if (data.options.onclick != null) {
            GEvent.addListener(marker, "click", function(latlng) {
                RichFaces.GmapMarkers.eval(data.options.onclick, {'marker':this,'latlng':latlng});
            })
        }
        gmap.addOverlay(marker);
        if (data.infoWindowId != null) {
            marker.bindInfoWindow(document.getElementById(data.infoWindowId));
        }
    }
};
/**
 * This function evaluates code in template with object in ScopeChain.
 * This is usefull if you need to evaluate code that uses member names
 * that colide with external names that the code refers to.
 * There is almost exact method in utils.js called Richfaces.eval,
 * but it swallows exception thrown during evaluation, which makes debugging
 * hard.
 */
RichFaces.GmapMarkers.eval = function(template, object) {
    var value;
    with (object) {
        value = eval(template);
    }
    return value;
};