if (!window.RichFaces) window.RichFaces = {};
RichFaces.ImageSelectTool = function(selectorId, inputId, forId, options) {
    /**
     * domNode is element representing imageSelectTool component
     */
    var domNode = document.getElementById(selectorId);
    var input = jQuery(document.getElementById(inputId));
    var delegate;
    var fireChangeListener = function(event) {
        if (typeof(options.onchange) === "function") {
            options.onchange(event);
        } else if (typeof(options.onchange) === "string") {
            eval(options.onchange);
        }
    };
    var fireSelectListener = function(event) {
        if (typeof(options.onselect) === "function") {
            options.onselect(event);
        } else if (typeof(options.onselect) === "string") {
            eval(options.onselect);
        }
    };
    var updateInput = function(event) {
        input.val(event.x + ";" + event.y + ";" + event.width + ";" + event.height);
    };
    var detach = function() {
        delete domNode.component;
    };
    if (domNode.component != null && typeof domNode.component.destroy == "function") {
        domNode.component.destroy();
    }
    domNode.component = this;
    options = options || {};
    options.onChange = function(event) {
        event = {
            x:event.x,
            y:event.y,
            width:event.w,
            height:event.h
        };
        updateInput(event);
        fireChangeListener(event);
    };
    options.onSelect = function(event) {
        event = {
            x:event.x,
            y:event.y,
            width:event.w,
            height:event.h
        };
        updateInput(event);
        fireSelectListener(event);
    };
    if (options.minWidth != null && options.minHeight != null) {
        options.minSize = [ options.minWidth, options.minHeight ];
    }
    if (options.maxWidth != null && options.maxHeight != null) {
        options.maxSize = [ options.maxWidth, options.maxHeight ];
    }
    if (options.selection) {
        options.setSelect = [
            options.selection.x,
            options.selection.y,
            options.selection.x + options.selection.width,
            options.selection.y + options.selection.height
        ];
    }
    options.bgColor = options.backgroundColor;
    options.bgOpacity = options.backgroundOpacity;

    //initialize Jcrop
    function initialize() {
        var image = document.getElementById(forId);

        function doInitialize() {
            delegate = jQuery.Jcrop(image, options);
        }

        if (image.complete) {
            doInitialize();
        } else {
            image.onload = doInitialize;
        }
    }

    if (options.ajaxRequest) {
        initialize();
    } else {
        jQuery(initialize());
    }

    return {
        setSelection : function(x, y, w, h) {
            var event = {x:x,y:y,width:w,height:h};
            updateInput(event);
            delegate.setSelect([x,y,x + w,y + h]);
            fireSelectListener(this.getSelection());
        },
        animateTo : function(x, y, w, h) {
            var event = {x:x,y:y,width:w,height:h};
            updateInput(event);
            delegate.animateTo([x,y,x + w,y + h]);
            fireSelectListener(event);
        },
        setOptions : function(options) {
            delegate.setOptions(options);
        },
        getSelection : function() {
            var selection = delegate.tellSelect();
            return {
                x:selection.x,
                y:selection.y,
                width:selection.w,
                height:selection.h
            };
        },
        getScaledSelection : function() {
            var selection = delegate.tellScaled();
            return {
                x:selection.x,
                y:selection.y,
                width:selection.w,
                height:selection.h
            };
        },
        disable : function() {
            delegate.disable();

        },
        enable : function() {
            delegate.enable();
        },
        focus : function() {
            delegate.focus();
        },
        getBounds : function() {
            return delegate.getBounds();
        },
        getWidgetSize : function() {
            return delegate.getWidgetSize();
        },
        release : function() {
            delegate.release();
        },
        destroy : function() {
            delegate.destroy();
            detach();
        }
    };
};