package org.richfaces.renderkit.html;

import org.ajax4jsf.renderkit.HeaderResourcesRendererBase;
import org.ajax4jsf.renderkit.ProducerContext;
import org.ajax4jsf.resource.InternetResource;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.richfaces.component.UIJQueryPlugin;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import java.io.IOException;

public class JQueryPluginRenderer extends HeaderResourcesRendererBase {

    private static Log logger = LogFactory.getLog(JQueryPluginRenderer.class);

    /**
     * It's not an error, second jquery.js is just to avoid NullPointerException and should be overwritten
     * in encodeToHead.
     */
    private final InternetResource[] scripts = {
        getResource("/org/richfaces/renderkit/html/scripts/jquery/jquery.js"),
        getResource("/org/richfaces/renderkit/html/scripts/jquery/jquery.js")
    };

    @Override
    protected InternetResource[] getScripts() {
        return scripts;
    }

    @Override
    protected Class<? extends UIComponent> getComponentClass() {
        return UIJQueryPlugin.class;
    }

    @Override
    public void encodeToHead(FacesContext context, UIComponent component, ProducerContext pc) throws IOException {
        if (component instanceof UIJQueryPlugin) {
            final String src = ((UIJQueryPlugin) component).getSrc();
            try {
                scripts[1] = getResource(src);
            } catch (Exception e) {
                logger.error("Problem with loading source for component " + component.getId() + ".", e);
            }
        }
        super.encodeToHead(context, component, pc);
    }
}
