package org.richfaces.renderkit.html;

import org.ajax4jsf.renderkit.RendererBase;
import org.richfaces.component.UIRadio;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import java.io.IOException;

public class SingleRadioRenderer extends RendererBase {
    private String convertToString(Object obj) {
        return (obj == null ? "" : obj.toString());
    }

    @Override
    protected void doEncodeEnd(ResponseWriter writer, FacesContext context, UIComponent _component) throws IOException {
        UIRadio component = (UIRadio) _component;
        java.lang.String clientId = component.getClientId(context);
        final UIComponent targetComponent = getUtils().findComponentFor(component, component.getFor());
        final javax.faces.model.SelectItem item = component.getSelectItem(context, targetComponent);
        boolean checked = false;
        if (targetComponent instanceof javax.faces.component.UIOutput) {
            final Object currentValue = ((javax.faces.component.UIOutput) targetComponent).getValue();
            final Object itemValue = item.getValue();
            checked = itemValue == null ? currentValue == null : itemValue.equals(currentValue);
        }

        writer.startElement("input", component);
        getUtils().writeAttribute(writer, "id", clientId);
        getUtils().writeAttribute(writer, "name", getUtils().clientId(context, targetComponent));
        getUtils().writeAttribute(writer, "type", "radio");
        getUtils().writeAttribute(writer, "value", item.getValue());
        if (checked) {
            getUtils().writeAttribute(writer, "checked", "checked");
        }
        //
// pass thru attributes
//
        getUtils().encodeAttributesFromArray(context, component, new String[]{
                "accept",
                "accesskey",
                "align",
                "alt",
                "checked",
                "dir",
                "disabled",
                "lang",
                "maxlength",
                "onblur",
                "onchange",
                "onclick",
                "ondblclick",
                "onfocus",
                "onkeydown",
                "onkeypress",
                "onkeyup",
                "onmousedown",
                "onmousemove",
                "onmouseout",
                "onmouseover",
                "onmouseup",
                "onselect",
                "readonly",
                "size",
                "src",
                "style",
                "tabindex",
                "title",
                "usemap",
                "xml:lang"});

        writer.endElement("input");
        writer.startElement("label", component);
        getUtils().writeAttribute(writer, "for", clientId);

        writer.writeText(convertToString(item.getLabel()), null);

        writer.endElement("label");
    }

    @Override
    protected Class<? extends UIComponent> getComponentClass() {
        return UIRadio.class;
    }
}
