package org.richfaces.component.event;

import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;
import java.util.Date;

public class ScheduleDateRangeChangeEvent extends FacesEvent {
// ------------------------------ FIELDS ------------------------------

    private Date endDate;

    private Date startDate;

// --------------------------- CONSTRUCTORS ---------------------------

    public ScheduleDateRangeChangeEvent(UIComponent component, Date startDate, Date endDate) {
        super(component);
        this.startDate = startDate;
        this.endDate = endDate;
    }

// --------------------- GETTER / SETTER METHODS ---------------------

    public Date getEndDate() {
        return endDate;
    }

    public Date getStartDate() {
        return startDate;
    }

// ------------------------ CANONICAL METHODS ------------------------

    @Override
    public String toString() {
        return getClass().getSimpleName() + "[startDate=" + startDate + ";endDate=" + endDate + "]";
    }

// -------------------------- OTHER METHODS --------------------------

    @Override
    public boolean isAppropriateListener(FacesListener listener) {
        return listener instanceof ScheduleDateRangeChangeListener;
    }

    @Override
    public void processListener(FacesListener listener) {
        ((ScheduleDateRangeChangeListener) listener).dateRangeChanged(this);
    }
}
