package org.richfaces.component.event;

import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;
import java.util.Date;

public class ScheduleDateRangeSelectEvent extends FacesEvent {
// ------------------------------ FIELDS ------------------------------

    private boolean allDay;

    private Date endDate;

    private Date startDate;

// --------------------------- CONSTRUCTORS ---------------------------

    public ScheduleDateRangeSelectEvent(UIComponent component, Date startDate, Date endDate, boolean allDay) {
        super(component);
        this.startDate = startDate;
        this.endDate = endDate;
        this.allDay = allDay;
    }

// --------------------- GETTER / SETTER METHODS ---------------------

    public Date getEndDate() {
        return endDate;
    }

    public Date getStartDate() {
        return startDate;
    }

    public boolean isAllDay() {
        return allDay;
    }

// ------------------------ CANONICAL METHODS ------------------------

    @Override
    public String toString() {
        return getClass().getSimpleName() + "[startDate=" + startDate + ";endDate=" + endDate + ";allDay=" + allDay + "]";
    }

// -------------------------- OTHER METHODS --------------------------

    public boolean isAppropriateListener(FacesListener facesListener) {
        return facesListener instanceof ScheduleDateSelectListener;
    }

    public void processListener(FacesListener facesListener) {
        ((ScheduleDateRangeSelectListener) facesListener).dateRangeSelected(this);
    }
}
