package org.richfaces.component.event;

import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;
import java.util.Date;

public class ScheduleDateSelectEvent extends FacesEvent {
// ------------------------------ FIELDS ------------------------------

    private boolean allDay;

    private Date date;

// --------------------------- CONSTRUCTORS ---------------------------

    public ScheduleDateSelectEvent(UIComponent component, Date date, boolean allDay) {
        super(component);
        this.date = date;
        this.allDay = allDay;
    }

// --------------------- GETTER / SETTER METHODS ---------------------

    public Date getDate() {
        return date;
    }

    public boolean isAllDay() {
        return allDay;
    }

// ------------------------ CANONICAL METHODS ------------------------

    @Override
    public String toString() {
        return getClass().getSimpleName() + "[date=" + date + ";allDay=" + allDay + "]";
    }

// -------------------------- OTHER METHODS --------------------------

    public boolean isAppropriateListener(FacesListener facesListener) {
        return facesListener instanceof ScheduleDateSelectListener;
    }

    public void processListener(FacesListener facesListener) {
        ((ScheduleDateSelectListener) facesListener).dateSelected(this);
    }
}
