package org.richfaces.component.event;

import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;

public class ScheduleItemMoveEvent extends FacesEvent {
// ------------------------------ FIELDS ------------------------------

    private boolean allDay;

    private int dayDelta;

    private String eventId;

    private int minuteDelta;

// --------------------------- CONSTRUCTORS ---------------------------

    public ScheduleItemMoveEvent(UIComponent component, String eventId, int dayDelta, int minuteDelta, boolean allDay) {
        super(component);
        this.eventId = eventId;
        this.dayDelta = dayDelta;
        this.minuteDelta = minuteDelta;
        this.allDay = allDay;
    }

// --------------------- GETTER / SETTER METHODS ---------------------

    public int getDayDelta() {
        return dayDelta;
    }

    public String getEventId() {
        return eventId;
    }

    public int getMinuteDelta() {
        return minuteDelta;
    }

    public boolean isAllDay() {
        return allDay;
    }

// ------------------------ CANONICAL METHODS ------------------------

    @Override
    public String toString() {
        return getClass().getSimpleName() + "[eventId=" + eventId + ";dayDelta=" + dayDelta
            + ";minuteDelta=" + minuteDelta + ";allDay=" + allDay + "]";
    }

// -------------------------- OTHER METHODS --------------------------

    public boolean isAppropriateListener(FacesListener facesListener) {
        return facesListener instanceof ScheduleItemMoveListener;
    }

    public void processListener(FacesListener facesListener) {
        ((ScheduleItemMoveListener) facesListener).itemMove(this);
    }
}
