package org.richfaces.component.event;

import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;

public class ScheduleItemResizeEvent extends FacesEvent {
// ------------------------------ FIELDS ------------------------------

    private int dayDelta;

    private String eventId;

    private int minuteDelta;

// --------------------------- CONSTRUCTORS ---------------------------

    public ScheduleItemResizeEvent(UIComponent component, String eventId, int dayDelta, int minuteDelta) {
        super(component);
        this.eventId = eventId;
        this.dayDelta = dayDelta;
        this.minuteDelta = minuteDelta;
    }

// --------------------- GETTER / SETTER METHODS ---------------------

    public int getDayDelta() {
        return dayDelta;
    }

    public String getEventId() {
        return eventId;
    }

    public int getMinuteDelta() {
        return minuteDelta;
    }

// ------------------------ CANONICAL METHODS ------------------------

    @Override
    public String toString() {
        return getClass().getSimpleName() + "[eventId=" + eventId + ";dayDelta=" + dayDelta
            + ";minuteDelta=" + minuteDelta + "]";
    }

// -------------------------- OTHER METHODS --------------------------

    public boolean isAppropriateListener(FacesListener facesListener) {
        return facesListener instanceof ScheduleItemResizeListener;
    }

    public void processListener(FacesListener facesListener) {
        ((ScheduleItemResizeListener) facesListener).itemResize(this);
    }
}
