package org.richfaces.component.event;

import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;

public class ScheduleItemSelectEvent extends FacesEvent {
// ------------------------------ FIELDS ------------------------------

    private String eventId;

// --------------------------- CONSTRUCTORS ---------------------------

    public ScheduleItemSelectEvent(UIComponent component, String eventId) {
        super(component);
        this.eventId = eventId;
    }

// --------------------- GETTER / SETTER METHODS ---------------------

    public String getEventId() {
        return eventId;
    }

// ------------------------ CANONICAL METHODS ------------------------

    @Override
    public String toString() {
        return getClass().getSimpleName() + "[eventId=" + eventId + "]";
    }

// -------------------------- OTHER METHODS --------------------------

    public boolean isAppropriateListener(FacesListener facesListener) {
        return facesListener instanceof ScheduleItemSelectListener;
    }

    public void processListener(FacesListener facesListener) {
        ((ScheduleItemSelectListener) facesListener).itemSelected(this);
    }
}
