package org.richfaces.taglib;

import com.sun.facelets.FaceletContext;
import com.sun.facelets.tag.MetaRule;
import com.sun.facelets.tag.MetaRuleset;
import com.sun.facelets.tag.Metadata;
import com.sun.facelets.tag.MetadataTarget;
import com.sun.facelets.tag.TagAttribute;
import com.sun.facelets.tag.jsf.ComponentConfig;
import com.sun.facelets.tag.jsf.ComponentHandler;
import org.richfaces.event.NodeExpandedEvent;
import org.richfaces.event.NodeSelectedEvent;

import javax.faces.component.UIComponent;
import javax.faces.el.MethodBinding;

public class ScheduleTagHandlerBase extends ComponentHandler {
// ------------------------------ FIELDS ------------------------------

    private final static String DATE_RANGE_CHANGED_LISTENER = "dateRangeChangeListener";

    private final static String DATE_SELECTED_LISTENER = "dateSelectListener";

    private final static String ITEM_MOVE_LISTENER = "itemMoveListener";

    private final static String ITEM_RESIZE_LISTENER = "itemResizeListener";

    private final static String ITEM_SELECTED_LISTENER = "itemSelectListener";

    private final static String VIEW_CHANGED_LISTENER = "viewChangeListener";

// --------------------------- CONSTRUCTORS ---------------------------

    public ScheduleTagHandlerBase(ComponentConfig config) {
        super(config);
    }

    @Override
    protected MetaRuleset createMetaRuleset(Class clazz) {
        MetaRuleset ruleset = super.createMetaRuleset(clazz);

        ruleset.addRule(new MetaRule() {
            public Metadata applyRule(String name, final TagAttribute attribute, MetadataTarget metadataTarget) {
                if (DATE_RANGE_CHANGED_LISTENER.equals(name)) {
                    return new Metadata() {
                        public void applyMetadata(FaceletContext context, Object object) {
                            MethodBinding binding = context.getFacesContext().getApplication().createMethodBinding(attribute.getValue(), new Class[]{NodeExpandedEvent.class});
                            ((UIComponent) object).getAttributes().put(DATE_RANGE_CHANGED_LISTENER, binding);
                        }
                    };
                } else if (DATE_SELECTED_LISTENER.equals(name)) {
                    return new Metadata() {
                        public void applyMetadata(FaceletContext context, Object object) {
                            MethodBinding binding = context.getFacesContext().getApplication().createMethodBinding(attribute.getValue(), new Class[]{NodeSelectedEvent.class});
                            ((UIComponent) object).getAttributes().put(DATE_SELECTED_LISTENER, binding);
                        }
                    };
                } else if (ITEM_RESIZE_LISTENER.equals(name)) {
                    return new Metadata() {
                        public void applyMetadata(FaceletContext context, Object object) {
                            MethodBinding binding = context.getFacesContext().getApplication().createMethodBinding(attribute.getValue(), new Class[]{NodeSelectedEvent.class});
                            ((UIComponent) object).getAttributes().put(ITEM_RESIZE_LISTENER, binding);
                        }
                    };
                } else if (ITEM_MOVE_LISTENER.equals(name)) {
                    return new Metadata() {
                        public void applyMetadata(FaceletContext context, Object object) {
                            MethodBinding binding = context.getFacesContext().getApplication().createMethodBinding(attribute.getValue(), new Class[]{NodeSelectedEvent.class});
                            ((UIComponent) object).getAttributes().put(ITEM_MOVE_LISTENER, binding);
                        }
                    };
                } else if (ITEM_SELECTED_LISTENER.equals(name)) {
                    return new Metadata() {
                        public void applyMetadata(FaceletContext context, Object object) {
                            MethodBinding binding = context.getFacesContext().getApplication().createMethodBinding(attribute.getValue(), new Class[]{NodeSelectedEvent.class});
                            ((UIComponent) object).getAttributes().put(ITEM_SELECTED_LISTENER, binding);
                        }
                    };
                } else if (VIEW_CHANGED_LISTENER.equals(name)) {
                    return new Metadata() {
                        public void applyMetadata(FaceletContext context, Object object) {
                            MethodBinding binding = context.getFacesContext().getApplication().createMethodBinding(attribute.getValue(), new Class[]{NodeSelectedEvent.class});
                            ((UIComponent) object).getAttributes().put(VIEW_CHANGED_LISTENER, binding);
                        }
                    };
                }

                return null;
            }
        });

        return ruleset;
    }
}
